import org.gicentre.processing.utils.stat.*;    // For chart classes.
import org.gicentre.processing.utils.colour.*;  // For colour tables.

// Sketch to demonstrate the use of the BarChart class to draw simple bar charts.
// Version 1.0, 11th May, 2010.
// Author Jo Wood.

// ------------------ Class and object variables --------------------

BarChart barChart;

// ------------------------ Initialisation --------------------------

/** Creates a set of points from which the standard ellipses will be calculated.
  */
void setup()
{
  size(800,300);
  smooth();
  
  PFont font = createFont("Helvetica",11);
  textFont(font,10);

  
  barChart = new BarChart(this);
  barChart.setData(new float[] {2462,2801,3280,3983, 4490, 4894, 5642, 6322, 6489,
                                6401,7657,9649,9767,12167,15154,18200,23124,28645});
  barChart.setBarLabels(new String[] {"1830","1840","1850","1860","1870","1880","1890",
                                      "1900","1910","1920","1930","1940","1950","1960",
                                      "1970","1980","1990","2000"});
  barChart.setBarColour(color(200,80,80,100));
  barChart.setBarGap(2); 
  barChart.setValueFormat("$###,###");
  barChart.showValueAxis(true); 
  barChart.showCategoryAxis(true); 
 
 
/*
  ColourTable cTable = new ColourTable();
  cTable.addDiscreteColourRule(1,240,50,50);
  cTable.addDiscreteColourRule(2,60,60,220);
  cTable.addDiscreteColourRule(3,250,140,30);
  cTable.addDiscreteColourRule(4,40,220,40);
  
  barChart = new BarChart(this);
  barChart.setData(new float[] {64.5,58.8,53.4,31.3});
  barChart.setMinValue(0);
  barChart.setBarGap(10);
  barChart.setBarLabels(new String[]{"Gordon Brown","David Cameron","Nick Clegg","Caroline Lucas"});
  barChart.showValueAxis(true);
  barChart.setValueFormat("#");
  barChart.showCategoryAxis(true);
  barChart.setBarColour(new float[] {1,2,3,4},cTable);
  */
}

// ------------------ Processing draw --------------------

/** Draws the points, randomly perturbs them and draws their standard ellipse.
 */
void draw()
{
  background(255);
  
  barChart.draw(10,10,width-20,height-20);
  fill(120);
  textSize(22);
  text("Income per person, United Kingdom", 70,30);
  float textHeight = textAscent();
  textSize(12);
  text("Gross domestic product measured in inflation-corrected $US", 70,30+textHeight);
  
 
}
